
#define NOISE debug_noise
#define INFO debug_info
#define WARNING debug_warning
#define ERROR debug_error
#define FATAL debug_fatal

/** initialize debug */
void debug_init(void);

/** sets the level of debugging messages desired */
void debug_set_level(uint level);

/** print messages that are only for debugging purpose */
void debug_noise(bool flag, char *format, ...);

/** print information such as status was set, or mode changed */
void debug_info(bool flag, char *format, ...);

/** 
 * print warnings that are does not affect the normal operation of the program
 * that user should take notice.
 */
void debug_warning(bool flag, char *format, ...);

/**
 * print error that program encounter and program might exit because of the 
 * error.
 */
void debug_error(bool flag, char *format, ...);

/** print fatal error that program must exit now */
void debug_fatal(bool flag, char *format, ...);

/** print stuff that must be printed such as usage */
void debug_print(char *level, char *format, ...);


